/**********************************************
 *
 * function node used in a factor graph
 *
 *******************************************/

#ifndef FUNCTIONNODEH
#define FUNCTIONNODEH
#include "Node.h"
#include "LocalFunction.h"

class FunctionNode : public Node {

public:

  // constructor (has an additional argument compared to the superclass)
  FunctionNode(const char *name, int id, int numNeighbours, LocalFunction *localFunction);
  
  // implementation of the inherited abstract method
  virtual  void update(int port);

  virtual void reset(void);

  // issues a textual description of the current configuration of this node
  // (for debugging purposes)
  void draw(void);

  // issues a textual description of the current configuration of this node into a file
  // (for debugging purposes)
  void draw(FILE *file);

protected:

  LocalFunction *localFunction;

private:

  void summation(int neighbourIndex, int *tempConfiguration, int fixVariableIndex, int fixVariableValue, double& sum);

};

#endif


