/**********************************************
 *
 * Parity ckeck node used in a factor graph
 *
 *******************************************/

#ifndef PARITYCHECKNODEH
#define PARITYCHECKNODEH
#include "FunctionNode.h"
#include "LocalFunction.h"
//#include "TrellisFunctionNode.h"
#include "VariableNode.h"


class ParityCheckNode : public FunctionNode {

public:

  ParityCheckNode(const char *name, int id, int numNeighbours);
  
  // implementation of the inherited abstract method
  void update(int port);

  virtual void updateAll();

  void reset(void);

  // issues a textual description of the current configuration of this node
  // (for debugging purposes)
  void draw(void);

  // issues a textual description of the current configuration of 
  //this node into a file
  // (for debugging purposes)
  void draw(FILE *file);

 private:

  double LogModPlus(double, double);
  double jacobiFunction(double);
  double LogModMinus(double, double);
  double LogModMinusQuan(double);
};

#endif




